"""
Search for a value in a sorted list

Binary search:

low = 0
high = len(L)

while <stopping condition>:  
    mid = (low+high)//2
    if searched value is greater than middle value:
         low = mid point
    else:
         high = mid point
    print ("Debug info")
    input()
return low or high as the potential index
        of where this value could be
        
        
Since the size of the list being considered is
divided by 2 at each point

If there are N items, I can do this at most log(N,2)
times

So, searching within N items will require  log(N)
comparisons

"""

import random


def bin_search(L, val):
    ''' Assumes list L is sorted, find
    location of value val if it is in L
    
    '''
    
    low = 0  ##index of the first element
    high = len(L)-1 ## index of the last element
    while low != high:
        mid = (low+high)//2
        if L[mid] < val:
            low = mid+1
        else:
            high = mid
    if L[low] == val:
        return low
    else:
        return None


L = []

for i in range(10):
    L.append( random.randrange(1,100) )
    
L.sort()

print (L)